import { world, system, BlockPermutation } from "@minecraft/server";
const config = {
    altura_generacion: 100,
    area_de_generacion: 100
};
function chest() {
    const players = world.getAllPlayers();
    const randomIndex = Math.floor(Math.random() * players.length);
    const randomPlayer = players[randomIndex];
    const ubicacion = randomPlayer.location;
    const halfSize = Math.floor(config.area_de_generacion / 2);
    const esquinaSuperiorIzquierda = {
        x: ubicacion.x - halfSize,
        y: config.altura_generacion,
        z: ubicacion.z + halfSize
    };
    const esquinaInferiorDerecha = {
        x: ubicacion.x + halfSize,
        y: config.altura_generacion,
        z: ubicacion.z - halfSize
    };
    const spawn = spawnChest(esquinaSuperiorIzquierda, esquinaInferiorDerecha);
    world.getDimension(randomPlayer.dimension.id).spawnEntity('generator:chest', { x: spawn.x, y: spawn.y, z: spawn.z });
    world.getDimension(randomPlayer.dimension.id).runCommand(`tickingarea add circle ${spawn.x} ${spawn.y} ${spawn.z} 3 chest`)
}
function spawnChest(esquina1, esquina2) {
    const randomX = Math.floor(Math.random() * (esquina2.x - esquina1.x + 1)) + esquina1.x;
    const randomZ = Math.floor(Math.random() * (esquina1.z - esquina2.z + 1)) + esquina2.z;
    const randomY = esquina1.y;
    const newUbication = { x: randomX, y: randomY, z: randomZ };
    return newUbication;
}
function generator_detect() {
    try {
        let dimension = world.getDimension('overworld');
        const entities = dimension.getEntities({ type: "generator:chest" });
        entities.forEach(entity => {
            const ubication = entity.location;
            const blockLocation = { x: ubication.x, y: ubication.y, z: ubication.z };
            const detectBlock = { x: ubication.x, y: ubication.y - 1, z: ubication.z };
            let block = dimension.getBlock(detectBlock);
            dimension.spawnParticle("minecraft:basic_smoke_particle", { x: ubication.x, y: ubication.y, z: ubication.z });
            dimension.spawnParticle("minecraft:basic_smoke_particle", { x: ubication.x, y: ubication.y, z: ubication.z });
            dimension.spawnParticle('minecraft:redstone_ore_dust_particle', { x: ubication.x, y: ubication.y, z: ubication.z });
            dimension.spawnParticle("minecraft:basic_smoke_particle", { x: ubication.x, y: ubication.y, z: ubication.z });
            dimension.spawnParticle("minecraft:basic_smoke_particle", { x: ubication.x, y: ubication.y, z: ubication.z });
            dimension.spawnParticle('minecraft:redstone_ore_dust_particle', { x: ubication.x, y: ubication.y, z: ubication.z });
            dimension.spawnParticle("minecraft:basic_smoke_particle", { x: ubication.x, y: ubication.y, z: ubication.z });
            dimension.spawnParticle("minecraft:basic_smoke_particle", { x: ubication.x, y: ubication.y, z: ubication.z });
            if (block.typeId != 'minecraft:air') {
                block = dimension.getBlock(blockLocation);
                block.setPermutation(BlockPermutation.resolve('minecraft:chest'));
                entity.runCommand(`loot insert ${blockLocation.x} ${blockLocation.y} ${blockLocation.z} loot "${Math.floor(Math.random() * 460 + 1)}"`);
                entity.triggerEvent('chest:despawn');
                dimension.runCommand('tickingarea removeall')
            }
        });} catch (e) {} 
}
system.runInterval(() => generator_detect());
system.runInterval(() => chest(), 300);
